/* Damian Mehers - see http://bigbird.geo.dec.com/rv/read_vaxmail.html for
   full info - but basically, this is untested, certainly buggy, and
   very much in the experimental stage!
*/

#include <stdio>
#include <descrip>
#include <ctype>
#include <ssdef>
#include <maildef>
#include <ucx$inetdef.h>
#include <socket.h>
#include <in.h>
#include <inet.h>

#define MAIL$_MSGINFO 8322313
#define MAIL$_MSGTEXT 8322305
int folder_routine(void* dummy,  struct  dsc$descriptor  *name);

static void selMessage(char* message);

int fc = 0;
int mc = 0;
char from[255], subject[255], chunk[255];
int fromLen = 0, subjectLen = 0, chunkLen = 0;
unsigned int messageId;
int s2;	    

typedef  struct  itmlst
{
	short  buffer_length;
	short  item_code;
	long  buffer_address;
	long  return_length_address;
}  ITMLST;
static ITMLST nl[] = { {0,0,0,0} };
ITMLST mailfile_info_itmlst[]  =  {
	{4,MAIL$_MAILFILE_FOLDER_ROUTINE,folder_routine,0},
	{0,0,0,0} };

ITMLST message_in_itmlst[]  =  {
	{sizeof(fc),MAIL$_MESSAGE_FILE_CTX,&fc,0},
	{0,0,0,0} };

ITMLST message_select_in_itmlst[]  =  {
	{0,MAIL$_MESSAGE_FOLDER,0,0},
	{0,0,0,0} };

ITMLST message_info_in_itmlst[] = {
	{0, MAIL$_MESSAGE_NEXT, 0, 0},
	{0, MAIL$_NOSIGNAL, 0, 0},
	{0,0,0,0} };

ITMLST message_info_out_itmlst[]  =  {
	{sizeof(messageId), MAIL$_MESSAGE_CURRENT_ID, &messageId, 0},
	{sizeof(from) - 1,MAIL$_MESSAGE_FROM,from,&fromLen},
	{sizeof(subject) - 1,MAIL$_MESSAGE_SUBJECT,subject,&subjectLen},
	{0,0,0,0} };

ITMLST message_get_1_in_itmlst[] = {
	{sizeof(messageId), MAIL$_MESSAGE_ID, &messageId, 0},
	{0,0,0,0} };
ITMLST message_get_in_itmlst[] = {
/*	{sizeof(messageId), MAIL$_MESSAGE_ID, &messageId, 0}, */
	{0, MAIL$_MESSAGE_CONTINUE, 0, 0},
	{0,0,0,0} };

ITMLST message_get_out_itmlst[]  =  {
	{sizeof(chunk) - 1,MAIL$_MESSAGE_RECORD,chunk,&chunkLen},
	{0,0,0,0} };

int folder_routine(void* dummy,  struct  dsc$descriptor  *name)
{
    if(name->dsc$w_length)
    {
	unsigned char lenChar = name->dsc$w_length;
	send(s2, &lenChar, 1, 0);
	send(s2, name->dsc$a_pointer, name->dsc$w_length, 0);
	printf("Send a folder!\n");
    }
    return(SS$_NORMAL);
}

main  (int  argc,  char  *argv[])
{
    unsigned int st;

    int s;
    struct sockaddr_in sin;
    int portNr;
    char portNrStr[255];

    printf("Port (I'd suggest somewhere above 2000)? ");
    gets(portNrStr);
    portNr = atoi(portNrStr);

    printf("Ok, using port nr %d\n", portNr);

    s = socket ( PF_INET, SOCK_STREAM, 0); 
    if(s ==0)
	    return;

    sin.sin_family = AF_INET; 
    sin.sin_addr.s_addr = 0; 
    sin.sin_port = htons(portNr);

    if (bind(s, &sin, sizeof (sin)) != 0)
        return;

    if(listen(s, 5) != 0)
	return;

    st = mail$mailfile_begin(&fc, nl, nl);

    if(st != SS$_NORMAL)
        exit(st);

    st = mail$mailfile_open(&fc, nl, nl);
    if(st != SS$_NORMAL)
        exit(st);

    for(;;)
    {
	printf("Waiting for a connection ... \n");
	s2 = accept (s,0,0);
	if(s2 == 0)
	    return;

	for(;;)
	{
	    char cmd[255], par[255];
	    char inBuf[1024];
	    int inBufLen = 0;

	    printf("Waiting for a command ... \n");
	    inBufLen = recv ( s2, inBuf, sizeof(inBuf) - 1, 0);

	    if(inBufLen == -1)
		break;

	    inBuf[inBufLen] = 0;
	    printf("Got a message:%s\n", inBuf);
	    sscanf(inBuf, "%s %s\n", cmd, par);

	    if(strcmp(cmd, "lf") == 0)
	    {
		unsigned char lenChar = 0;
		mail$mailfile_info_file(&fc, mailfile_info_itmlst, nl);
		send(s2, &lenChar, 1, 0);
	    }


	    else if(strcmp(cmd, "sf") == 0)
	    {
		unsigned char lenChar;
		message_select_in_itmlst[0].buffer_address = par;
		message_select_in_itmlst[0].buffer_length = strlen(par);

		if(mc != 0)
		{
		    mail$message_end(&mc,  nl,  nl);
		    mc = 0;
		}

		st = mail$message_begin(&mc, message_in_itmlst, nl);
		if(st != SS$_NORMAL)
		    exit(st);
		st = mail$message_select(&mc, message_select_in_itmlst, nl);
		while(st == SS$_NORMAL)
		{
		    if((st = mail$message_info(&mc,
					 message_info_in_itmlst,
					 message_info_out_itmlst)) == SS$_NORMAL)
		    {
			char buf[1024];
			from[fromLen] = '\0';
			subject[subjectLen] = '\0';
			sprintf(buf, "%d FROM: %s, SUBJ: %s\n", messageId, from, subject);
			printf("%d FROM: %s, SUBJ: %s\n", messageId, from, subject);
			lenChar = strlen(buf);
			send(s2, &lenChar, 1, 0);
			send(s2, buf, strlen(buf), 0);
		    }
		}
		lenChar = 0;
		send(s2, &lenChar, 1, 0);
	    }
	    else if(strcmp(cmd, "sm") == 0)
	    {
		unsigned char lenChar;
		messageId = atoi(par);
		st=mail$message_get(&mc,
				    message_get_1_in_itmlst,
				    message_get_out_itmlst);

		if(st == MAIL$_MSGINFO)
		{
		    st=mail$message_get(&mc, message_get_in_itmlst, message_get_out_itmlst);
		    while(st == MAIL$_MSGTEXT)
		    {
			if(chunkLen != 0)
			{
			    chunk[chunkLen] = 0;
			    lenChar = strlen(chunk);
			    send(s2, &lenChar, 1, 0);
			    send(s2, chunk, chunkLen, 0);
			    puts(chunk);
			}
			st=mail$message_get(&mc, message_get_in_itmlst, message_get_out_itmlst);
		    }
		}
		lenChar = 0;
		send(s2, &lenChar, 1, 0);
	    }
	    else if(strcmp(cmd, "ex") == 0)
		break;
	}
    }

    if(mc != 0)
        mail$message_end(&mc,  nl,  nl);
    mail$mailfile_close(&fc,  nl,  nl);
    mail$mailfile_end(&fc,  nl,  nl);
    return SS$_NORMAL;
}
static void selMessage(char* message)
{
}
